const { VUE_APP_ENV } = process.env;
let baseURL = 'https://dev-sc.yunqueyi.com';

if (VUE_APP_ENV == 'test') {
  baseURL = 'https://test1-sc.yunqueyi.com';
} else if (VUE_APP_ENV == 'uat') {
  baseURL = 'https://uat-sc.yunqueyi.com';
} else if (VUE_APP_ENV == 'prod') {
  baseURL = 'https://sc.yunqueyi.com';
}

export { baseURL };

// code message for reponse
export const codeMessage = {
  200: '服务器成功返回请求的数据。',
  201: '新建或修改数据成功。',
  202: '一个请求已经进入后台排队（异步任务）。',
  204: '删除数据成功。',
  400: '发出的请求有错误，服务器没有进行新建或修改数据的操作。',
  401: '用户没有权限（登录过期、token错误）',
  403: '用户得到授权，但是访问是被禁止的。',
  404: '发出的请求针对的是不存在的记录，服务器没有进行操作。',
  406: '请求的格式不可得。',
  410: '请求的资源被永久删除，且不会再得到的。',
  422: '当创建一个对象时，发生一个验证错误。',
  500: '服务器发生错误，请检查服务器。',
  502: '网关错误。',
  503: '服务不可用，服务器暂时过载或维护。',
  504: '网关超时。'
};

/**
 * axios basis config
 */
export default {
  baseURL: baseURL,
  headers: {
    'X-Requested-With': 'XMLHttpRequest',
    'Content-Type': 'application/json;charset=UTF-8'
  },
  timeout: 10000,
  withCredentials: true,
  responseType: 'json'
  // transformResponse: [function(data, headers) {}]
};
